﻿using System.Collections.Generic;
using System.Windows;
using Telerik.Windows.Controls;
using Telerik.Windows.Persistence;
using Telerik.Windows.Persistence.Services;

namespace WpfApp52
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            ServiceProvider.RegisterPersistenceProvider<ICustomPropertyProvider>(typeof(RadGridView), new GridViewCustomPropertyProvider());
            this.EnsureLoadState();

            this.DataContext = new List<RowInfo>()
            {
                new RowInfo() {  Info = "I1", Data = "D1"},
                new RowInfo() {  Info = "I2", Data = "D2"},
            };
        }
        System.IO.Stream stream;
        private void Save_Click(object sender, RoutedEventArgs e)
        {
            PersistenceManager manager = new PersistenceManager();
            this.stream = manager.Save(this.Content);
            
            this.EnsureLoadState();
        }

        private void Load_Click(object sender, RoutedEventArgs e)
        {
            this.stream.Position = 0L;
            PersistenceManager manager = new PersistenceManager();
            manager.Load(this.Content, this.stream);
            this.EnsureLoadState();
        }
        private bool CanLoad()
        {
            return this.stream != null && this.stream.Length > 0;
        }
        private void EnsureLoadState()
        {
            this.Load.IsEnabled = this.CanLoad();
        }
    }

    public class RowInfo
    {
        public string Data { get; set; }
        public string Info { get; set; }
    }
}
